/* atqgrammar.h -- Copyright (C)  2000-2008 Marco Cesati
 * Tue, 31 Aug 2004 14:55:17 +0200
 */
 
#ifndef _ATQGRAMMAR_H_
#define _ATQGRAMMAR_H_

extern int yylex(void);
extern char *yytext;
extern void yyrestart(FILE *);

enum { BAD=1, GOOD, QUESTION, MULQUESTION, COURSE, 
       DATE, TEACHER, GROUPS,  ADVISE, ATQFILE, FONTPITCH, PREAMBLE, 
       FORMVERSION, FORMDATE, FORMCOURSE, /* tokens end here */
       ARG, NUM, ERR };

#define MAXTOKEN FORMCOURSE

/* tokens are also defined in the atqgrammar.l flex file, please make any change in both places! */
static char *token[MAXTOKEN+1] __attribute__((unused)) = {
    "", "bad", "good", "question", "mulquestion", "course", 
    "date", "teacher", "groups", "advise", "atqfile", "fontpitch", "preamble",
    "formversion", "formdate", "formcourse" };

extern int _value;
extern int _linenum;
extern int _error;

#define ATLINE " in file %s at line %d\n"

static char *_errors[] __attribute__((unused)) = {
    "Number expected" ATLINE,              /* 0 */
    "Syntax error in groups field" ATLINE, /* 1 */
    "Syntax error" ATLINE,                 /* 2 */
    "Premature EOF (opening brace at line %d)\n", /* 3 */
    "Error in file name" ATLINE,           /* 4 */
    NULL };

#endif

extern void restart_atq_scanner(FILE *);
