/* form.h -- Copyright (C)  2000-2008 Marco Cesati
 * Fri, 18 Feb 2005 13:13:50 +0100
 */


#ifndef __FORM_H__
#define __FORM_H__

struct form_t {
    struct {
        double width;  /* width of crosses (mm) */
        double height; /* height of crosses (mm) */
        double hdist;  /* horizontal distance of crosses (mm) */ 
        double vdist;  /* vertical distance of crosses (mm) */
    } cross;
    struct {
        double width;  /* width of code marks (mm) */
        double height; /* height of code marks (mm) */
        double max_threshold;
        double min_threshold;
        double step_threshold;
        double skip_edge; 
        double vo[3];  /* voffsets from the bottom cross marks */
        double ho[10]; /* hoffsets from the left cross marks */
    } code;
    struct {
        int nquest;    /* number of text box lines */
        int nanswer;   /* number of text boxes in each line */
        double width;  /* width of answer boxes (mm) */
        double height; /* height of answer boxes (mm) */
        double threshold; /* threshold value for recognizing a mark */
        int skip_pixel;/* skip tolerance in pixel for marks */
        const double *vo; /* voffsets from the bottom cross marks for lines */
                       /* array size: nquest */
        const double *ho; /* hoffsets from the left cross marks for answers */
                       /* array size: nanswer */
    } answer; 
#if 0
    struct {
        int present;   /* 1 if example line is present, 0 otherwise */
        double vo;     /* voffsets from the bottom cross marks */
        unsigned short res; /* result of example line */
    } example;
#endif
};
        
extern const struct form_t *form;

extern char * str_answers(unsigned char code);
extern int max_form_version(void);
extern void set_form_version(int);
#endif /* __FORM_H__ */
